-- Fichier ts_poly1.adb
-- TP 13A
-- pour tester le paquetage P_Poly_Vl_G
-- le test sera refait trs srieusement aprs la testabilit
-- D.Feneuille

with P_Poly_V1_G;            -- use stupide !
with P_Rationnels_G;         -- use stupide !
with P_Rationnels_G.Io;      -- use stupide !
with Ada.Text_Io;            use Ada.Text_Io;

procedure Ts_Poly1 is 

   type T_Entier is range - 40000 .. 40000; 
   package P_Rationnels is new P_Rationnels_G(T_Entier);
   use P_Rationnels;
   package P_Rationnels_Io is new P_Rationnels.Io;
   use P_Rationnels_Io;

   package P_Poly_Vrai is new P_Poly_V1_G(10,P_Rationnels,P_Rationnels_Io);
   use P_Poly_Vrai;

   Poly1,  
   Poly2,  
   Poly3 : T_Polynome; -- trois polynmes   

begin

   Set(Poly3,(0/1,4/1,-2/1,1/1)); --  modifier !
   New_Line;
   Put("POLY3");
   New_Line;
   Ecrire(Poly3);
   New_Line;

   Set(Poly1,(-2/1,1/1,-2/1));  --  modifier !

   New_Line;
   Put ("POLYl");
   New_Line;
   Ecrire(Poly1);
   New_Line;

   Set(Poly2,(7/1,-1/1)); --  modifier

   New_Line;
   Put (" POLY2");
   New_Line;
   Ecrire(Poly2);
   New_Line;

   -- tests simples

   Put_Line ("Pl + P2 = ");
   Ecrire(Poly1 + Poly2);
   New_Line;
   Put_Line ("Pl - P2 = ");
   Ecrire(Poly1 - Poly2);
   New_Line;
   Poly3 := - Poly1;
   Put_Line ("Inverse de Pl");
   Ecrire(Poly3);
   New_Line;
   Put_Line ("Pl * P2 = ");
   Ecrire(Poly1 * Poly2);
   New_Line;
   Put_Line ("Drive de Pl : ");
   Ecrire(Derivee(Poly1));
   New_Line(2);
   Put_Line("quelques tests plus compliqus");
   New_Line;
   Put_Line ("POLY1 + (POLY1 * POLY2)");
   Ecrire(Poly1 + (Poly1 * Poly2));
   New_Line;
   Put_Line ("POLY1 + POLY1 * POLY2");
   Ecrire(Poly1 + Poly1 * Poly2);
   New_Line;
   Put_Line ("POLY1 * (POLY1 + POLY2)");
   Ecrire(Poly1 * (Poly1 + Poly2));
   New_Line;
   Put_Line ("POLY1 * POLY1 + POLY2");
   Ecrire(Poly1 * Poly1 + Poly2);
   New_Line;
   Put_Line ("(POLY1 * POLY1) + (POLY1 * POLY2)");
   Ecrire((Poly1 * Poly1) + (Poly1 * Poly2));
   New_Line;
   Put_Line ("POLY1 * POLY1 + POLY1 * POLY2");
   Ecrire(Poly1 * Poly1 + Poly1 * Poly2);
   New_Line;

   -- tests de rem et de /

   Set(Poly1,(4/1,-5/1,4/1));
   New_Line;
   Put ("POLYl");
   New_Line;
   Ecrire(Poly1);
   New_Line;

   Set(Poly2,(-1/1,0/1,1/1));
   New_Line;
   Put (" POLY2");
   New_Line;
   Ecrire(Poly2);

   Poly3:= Poly1 rem Poly2;
   New_Line;
   Put("reste de Poly1/Poly2");
   New_Line;
   Ecrire(Poly3);

   Poly3:= Poly1 / Poly2;
   New_Line;
   Put ("Quotient Poly1/Poly2");
   New_Line;
   Ecrire(Poly3);

   Set(Poly1,(-7/1,1/1,2/1,-8/1));
   New_Line;
   Put ("POLYl");
   New_Line;
   Ecrire(Poly1);
   New_Line;

   Set(Poly2,(-1/1,0/1,1/1));
   New_Line;
   Put (" POLY2");
   New_Line;
   Ecrire(Poly2);

   Poly3:= Poly1 rem Poly2;
   New_Line;
   Put("reste de Poly1/Poly2");
   New_Line;
   Ecrire(Poly3);

   Poly3:= Poly1 / Poly2;
   New_Line;
   Put ("Quotient Poly1/Poly2");
   New_Line;
   Ecrire(Poly3);

end Ts_Poly1;

-- Lancement ./ts_Poly1 > Fic_Poly.out
-- Comparez ensuite les deux fichiers Fic_Poly.out et Fic_Poly.Ora
-- Le fichier Fic_Poly.Ora est  envisager  chaque fois !!!