-- fichier   p_piece.ads
-- T. AVIGNON D.Feneuille
-- Novembre 98
-- fichier donn et comment en TD-TP 16

with Ada.Text_Io;         use  Ada.Text_Io;

package P_Piece is

   type T_Piece   is tagged private;

   procedure Get (P : out T_Piece);
   procedure Put (P : in  T_Piece);

private
   subtype T_Surface is Float range 0.0..60.0;
   type T_Nature_Sol is (Carrelage,Moquette,Parquet,Marbre,Ciment);
   type T_Piece  is tagged
      record
      Surface      : T_Surface;
      Nb_Fenetre   : Natural;
      Nature_Sol   :T_Nature_Sol;
   end record;

   package P_Float is new Ada.Text_Io.Float_Io(T_Surface);
   use P_Float;
   package P_Nature_Sol is new Ada.Text_Io.Enumeration_Io(T_Nature_Sol);
   use P_Nature_Sol;
   package P_Entier is new Ada.Text_Io.Integer_Io(Integer);
   use P_Entier;

end  P_Piece;
