-- pour TD TP Version 3 TP 17
-- test d'un paquetage P_Polynome (Boite noire)
-- La ralisation est suppose inconnue jouez le jeu !
-- Fichier p_poly_v1_g-v3.ads
-- D.F. T.A.  Novembre 2001

with Ada.Text_Io;           use Ada.Text_Io;

generic
package P_Poly_V1_G.V3 is

   -- exceptions :

   Exc_Depassement_Degre,
      Exc_Debordement_Coef ,
      Exc_Degre_Inexistant,
      Exc_Division_Zero,
      Exc_Lecture  : exception;

   function "+" (
         Poly_A,
         Poly_B : in     T_Polynome )
     return T_Polynome;
   function "-" (
         Poly_A : in     T_Polynome )
     return T_Polynome;
   function "*" (
         Poly_A,
         Poly_B : in     T_Polynome )
     return T_Polynome;
   function "/" (
         Poly_A,
         Poly_B : in     T_Polynome )
     return T_Polynome;
   function "rem" (
         Poly_A,
         Poly_B : in     T_Polynome )
     return T_Polynome;
   function Derivee (
         Poly_A : in     T_Polynome )
     return T_Polynome;
   procedure Set (
         Poly :    out T_Polynome;
         Vect : in     T_Liste_Coef );

   -- Entre-Sortie :
   procedure Put (
         Poly : in     T_Polynome ) renames Ecrire;
   procedure Get (
         Fich : in     File_Type;
         Poly :    out T_Polynome );

   -- accesseurs :
   function Get_Degre (
         Poly : in     T_Polynome )
     return Natural;
   -- rend le degr le plus lev du polynome aprs rduction

   function Get_Coef (
         Poly  : in     T_Polynome;
         Degre : in     Natural     )
     return T_Rationnel;
   -- rend la valeur du coefficient de degr DEGRE

   -- modifieur :
   procedure Set_Coef (
         Poly   : in out T_Polynome;
         Degre  : in     Natural;
         Valeur : in     T_Rationnel );
   -- change la valeur du coefficient de degr DEGRE

   -- autre :
   function Valeur (
         Poly : in     T_Polynome;
         X    : in     Float       )
     return Float;
   -- pour un FLOAT X rend la valeur POLY(X)

end P_Poly_V1_G.V3;
