-- D.F. novembre 2001
-- non donn aux tudiants c'est le travail  faire !
--
with Interfaces.C;            use Interfaces.C;
with Ada.Streams.Stream_Io;   use Ada.Streams.Stream_Io;
with Ada.Command_Line;        use Ada.Command_Line;
with Ada.Strings.Unbounded;   use Ada.Strings.Unbounded;
with Ada.Exceptions;          use Ada.Exceptions;
with Ada.Strings.Fixed;       use Ada.Strings.Fixed;
with Ada.Strings.Maps;        use Ada.Strings.Maps;
with Ada.Text_Io;             use Ada.Text_Io;

package body P_Tp19 is

   procedure Systeme (
         Comm : Char_Array );
   pragma Import (C,Systeme,"system");

   procedure Commande (
         La_Chaine : String ) is
   begin
      Systeme(To_C(La_Chaine));
   end Commande;

   package Reel_Io is new Float_Io(Float);
   use Reel_Io;

   Acronyme  : Unbounded_String;
   Les_Notes : Enreg;
   Fichier   : Ada.Streams.Stream_Io.File_Type;
   Moyenne   : Float;
   Pointeur  : Stream_Access;
   Texte     : Ada.Text_Io.File_Type;

   procedure Controle_Commande is
   begin
      if (Argument_Count /= 2) or else (Argument (1)'Length /= 1)
            or else (Index(Argument(1),To_Set("ncNC")) /= 1)
            then
         Raise_Exception (Exc_Commande'Identity,
            "il faut deux arguments (un caractre N ou C et l'acronyme)");
      end if;
   end Controle_Commande;

   procedure Controle_Acronyme is
   begin
      Open (Fichier,In_File,"notes");

      Pointeur := Stream(Fichier);
      loop
         exit when End_Of_File (Fichier);
         Acronyme := Unbounded_String'Input(Pointeur);
         Les_Notes := Enreg'Input(Pointeur);
         exit when Acronyme = To_Unbounded_String (Argument(2));
      end loop;
      if Acronyme /= To_Unbounded_String (Argument(2))
            then
         Raise_Exception (Exc_Acronyme'Identity,
            "l'acronyme n'est pas dans la base de donnes");
      end if;
      Close (Fichier);
   end Controle_Acronyme;

   procedure Calcul_Moyenne is
   begin
      Moyenne := 0.0;
      for Ind in Les_Notes.Vect'range
            loop
         Moyenne := Moyenne + Float(Les_Notes.Vect(Ind));
      end loop;
      if Les_Notes.Vect'Length /= 0
            then
         Moyenne := Moyenne / Float(Les_Notes.Vect'Length);
      end if;
   end Calcul_Moyenne;

   procedure Envoi_Moyenne is
   begin
      if (Argument(1) = "N") or (Argument(1) = "n")
            then
         Put ("la moyenne de " & Argument(2) & " est : ");
         Put (Moyenne,1,2,0);
         New_Line;
      else
         Create (Texte, Name => "envoi");
         Put (Texte,"la moyenne de " & Argument(2) & " est : ");
         Put (Texte,Moyenne,1,2,0);
         New_Line(Texte);
         Close(Texte);
         Commande("mail " & To_String(Acronyme) & " < envoi");
      end if;
   end Envoi_Moyenne;

end P_Tp19;

