-- pour TP 12B
-- insrez votre entte
-- fichier p_bounded_g-p_new_bounded_g.ads
-- vous pourrez aussi raliser d'autres mthodes !

generic
package P_Bounded_G.P_New_Bounded_G is


   function To_String (
         Source : in     Bounded_String ) 
     return String; 

   function To_Bounded_String (
         Source : in     String ) 
     return Bounded_String; 

   function "&" (
         Left,                         
         Right : in     Bounded_String ) 
     return Bounded_String; 

   function "&" (
         Left  : in     Bounded_String; 
         Right : in     Character       ) 
     return Bounded_String; 

   function "=" (
         Left,                         
         Right : in     Bounded_String ) 
     return Boolean; 

   function "<=" (
         Left,                         
         Right : in     Bounded_String ) 
     return Boolean; 

   function Index (
         Source  : in     Bounded_String; 
         Pattern : in     String          ) 
     return Length_Range; 

   procedure Insert (
         Source   : in out Bounded_String; 
         Before   : in     Positive;       
         New_Item : in     String          ); 

   procedure Delete (
         Source : in out Bounded_String; 
         From   : in     Positive;       
         Through : in     Natural         ); 

   procedure Overwrite (
         Source   : in out Bounded_String; 
         Position : in     Positive;       
         New_Item : in     String          ); 

   function "*" (
         Left  : in     Natural;  
         Right : in     Character ) 
     return Bounded_String; 

end P_Bounded_G.P_New_Bounded_G;
