-- TD-TP 13B
-- pour TD version 2: complment d'un paquetage Polynome
-- fichier p_poly_v1_g-v2.ads
-- D.F.   T.A. 2001
-- complment de la version 1 finie avant!

with Ada.Text_Io;             use Ada.Text_Io;

generic
package P_Poly_V1_G.V2 is

   -- on ajoute exceptions et d'autres mthodes (accesseurs et modifieurs).

   -- exceptions :

      Exc_Depassement_Degre,       --  not in 0..Max
      Exc_Debordement_Coef ,         -- not in T_Entier
      Exc_Degre_Inexistant,             -- not in 0..Degre
      Exc_Division_Zero,              -- sans commentaires
      Exc_Lecture                         
      : exception; 
   -- les exceptions sur polynomes contraints ne sont pas traites

   -- on complte les fonctions (surcharge) 
   -- qui vont grer les exceptions

   function "+" (Poly_A, Poly_B : in T_Polynome) return T_Polynome;
   function "-" (Poly_A, Poly_B : in T_Polynome) return T_Polynome;
   function "-" (Poly_A : in T_Polynome) return T_Polynome;
   function "*" (Poly_A, Poly_B : in T_Polynome) return T_Polynome;
   function "/" (Poly_A, Poly_B : in T_Polynome) return T_Polynome;
   function "rem" (Poly_A, Poly_B : in T_Polynome) return T_Polynome;
   function Derivee (Poly_A : in T_Polynome) return T_Polynome;
   procedure Set (Poly : out T_Polynome; Vect : in T_Liste_Coef);

   -- Entre-Sortie :
   procedure Put (Poly : in T_Polynome) renames Ecrire;
   procedure Get ( Fich : in File_Type; Poly : out T_Polynome);

   -- accesseurs :
   function Get_Degre (Poly : in T_Polynome) return Natural;
   -- rend le degr le plus lev du polynome aprs rduction

   function Get_Coef(Poly : in T_Polynome;Degre : in Natural)
      return T_Rationnel;
   -- rend la valeur du coefficient de degr DEGRE

   -- modifieur :
   procedure Set_Coef (Poly : in out T_Polynome; Degre : in Natural;
      Valeur : in T_Rationnel);
   -- change la valeur du coefficient de degr DEGRE

   -- autre :
   function Valeur (Poly : in T_Polynome; X : in Float) return Float;
   -- pour un FLOAT X rend la valeur POLY(X) (utile plus tard!)

end P_Poly_V1_G.V2;
