-- fichier ts_tp15_b.adb
-- D. Feneuille 98
-- TP 15

with Ada.Text_Io;             use Ada.Text_Io;
with P_Integr;
with Ada.Numerics.Generic_Elementary_Functions;
                              use Ada.Numerics;
with P_E_Sortie;              use P_E_Sortie; -- pour Image de Float

-- pour finir le tp2 numrique version attendue
-- ==========
-- integration de cosinus entre 0 et PI/2
-- puis entre PI/2 et PI et enfin entre 0 et PI
-- utilisation de INTEGRALE (qui utilise trapze et tangente)


procedure Ts_Tp15_B is 

   package Math_Lib is new Ada.Numerics.Generic_Elementary_Functions(
      Float);
   use Math_Lib;
   package Integr is new P_Integr(Float,Cos);
   use Integr;
   package P_Flot is new Ada.Text_Io.Float_Io(Float);

   Precis : Float;  
begin
   loop
      Put("entrez la prcision (0.0 pour finir) : ");
      P_Flot.Get(Precis);
      Skip_Line;
      exit when Precis <= 0.0;
      New_Line(2);
      Put_Line (" calcul COS entre 0 et PI/2: ");
      Put ("rsultat: ");
      Put(Image(Integrale(0.0,Pi/2.0,Precis)));
      New_Line;
      Put_Line (" calcul COS entre PI/2 et PI: ");
      Put ("resultat: ");
      Put(Image(Integrale(Pi/2.0,Pi,Precis)));
      New_Line;
      Put_Line (" calcul COS entre 0 et PI: ");
      Put ("resultat: ");
      Put(Image(Integrale(0.0,Pi,Precis)));
      New_Line;
   end loop;

end Ts_Tp15_B;

-- exercice  rendre programme de test d'intgrale de polynome
-- fin.in et fic.out  rendre. Rapport de test