-- fichier p_appartement.ads
-- T.  AVIGNON D.Feneuille
-- Novembre 98 TP 16
-- fichier donn et vu en TD 16 le body est  raliser compltement


with Ada.Finalization;      use  Ada.Finalization;

with P_Piece;                    use  P_Piece;
with P_Piece.Eau;                use P_Piece.Eau;
with P_Piece.Salon;              use P_Piece.Salon;
with P_Piece.Chambre;            use P_Piece.Chambre;
with P_Piece.Dependance;         use P_Piece.Dependance;

package P_Appartement is

   type T_Appartement is new Limited_Controlled  with
      record

      Cuisine       : T_Piece_D_Eau;
      Salle_De_Bain : T_Piece_D_Eau;
      Salon         : T_Piece_Salon;
      Chambre1      : T_Piece_Chambre;
      Chambre2      : T_Piece_Chambre;
      Cave          : T_Dependance;
      Numero_Id     : Positive;
   end record;

   procedure Get (Appart : out T_Appartement);
   procedure Put (Appart : in  T_Appartement);

   procedure Initialize (Objet : in out T_Appartement);
   procedure Finalize   (Objet : in out T_Appartement);
   function  Num_Id (Objet  : in T_Appartement) return  Positive ;
   function  Nb_Objet return  Natural;

end P_Appartement;
