-- Fichier Ts_Get_Coef.adb
-- pour tester le paquetage Poly_Vl_G.V3
-- lanceur du test de Get_Coef
--  raliser en Tp 17
-- D.Feneuille & T.Avignon
-- Novembre 2001

with P_Rationnels_G.Io;
with P_Poly_V1_G.V3; 
with Ada.Text_Io;             use Ada.Text_Io;
with Dri_Poly;

procedure Ts_Get_Coef is

   type T_Entier is range -40000..400000;
   
   package P_Rationnels is  new   P_Rationnels_G(T_Entier);
   package P_Rationnels_Io is new P_Rationnels.Io;
   
   use P_Rationnels;
   use P_Rationnels_Io;

   package P_Poly_Vrai1 is new P_Poly_V1_G(10,P_rationnels,P_Rationnels_Io);
   -- pas de use pour les ambiguts
   package P_Poly_Vrai is new P_Poly_Vrai1.V3;
   use P_Poly_Vrai;

   package E_S_Float is new Float_Io(Float);
   use E_S_Float;

   package Dri_Poly_Vrai is new Dri_Poly(T_Entier,10,P_Rationnels,P_Rationnels_Io,
                                                            P_Poly_Vrai1,P_Poly_Vrai);
   use Dri_Poly_Vrai;

begin
   Tst_Get_Coef;
end Ts_Get_Coef;
