-- fichier p_expression-_moi.adb
-- pour tudiants TP 18
--  finir ! en fonction des specifications grossies

with P_Token.Operateur;              use P_Token.Operateur;
with P_Token.Operateur.F;            use P_Token.Operateur.F;
with P_Token.Operande;               use P_Token.Operande;
with P_Token.Operande.F;             use P_Token.Operande.F;
with P_Token.Terminateur;            use P_Token.Terminateur;
with P_Token.Terminateur.F;          use P_Token.Terminateur.F;
with P_Token.Parenthese;             use P_Token.Parenthese;
with P_Token.Parenthese.F;           use P_Token.Parenthese.F;
with P_Pile_4;
with Ada.Text_Io;
with Ada.Strings.Unbounded.Text_Io;  use Ada.Strings.Unbounded.Text_Io;
                                     use Ada.Strings.Unbounded;
with Ada.Tags;                       use Ada.Tags;
with Ada.Exceptions;                 use Ada.Exceptions;

package body P_Expression.A_Moi is

   package P_Pile_Token is new P_Pile_4(T_Ptr_Token,Max_Car);
   package P_Pile_Prior is new P_Pile_4(Natural,Max_Car);
   use P_Pile_Token;
   use P_Pile_Prior;


   procedure Lire (L_Expres : out Unbounded_String) is
      Res : Unbounded_String;
      S : Unbounded_String;
   begin
      Ada.Text_Io.Put_Line("Entrez l'expression");
      S := Get_Line;

      for J in 1..Length(S) loop
         if Element(S,J) /= ' ' then

            Res :=Res & Element(S,J);
         end if;
      end loop;
      L_Expres :=  Res;
   exception
      when others => raise_exception(Exc_Erreur'Identity,"Erreur dans LIRE ");

   end Lire;

end P_Expression.A_Moi;


